
var widgetAPI = new Common.API.Widget();
var tvKey = new Common.API.TVKeyValue();
var pluginAPI = new Common.API.Plugin();

var Main =
{
    previousURL : null,
    currentURL  : null,
    state : "top",
    previousState : "top",
	
    windowTitle : "DR Bonanza",
    nextWindowTitle : "DR Bonanza",
    selectedVideo : 0,
    topSelect : 0,
    previousSelect : 0,
    mode : 0,
    mute : 0,
    inputMode : 4,
    sw : "",//Search word
    currentKey : null,
    searchTimeoutValue : 1000,
    infoTimeoutValue : 5000,
    infoMoveTimeoutValue : 10,
    splashTimeout : null,
    UP : -1,
    DOWN : 1,

    WINDOW : 0,
    FULLSCREEN : 1,
    
    NMUTE : 0,
    YMUTE : 1,
    IGNORE_ENTER : false,
    IGNORE_ALL : false
}

Main.splashDone = function()
{
    clearTimeout(Main.splashTimeout);
    document.getElementById("main").style.display="block";
    document.getElementById("splash").style.display="none";
    Main.inputMode = 0;
}

Main.onLoad = function()
{
window.onShow = onShowEvent;

    document.getElementById("main").style.display="block";

    if ( Display.init() && Server.init() )
    {

        // Start retrieving data from server
        Server.dataReceivedCallback = function()
        {
            alert("dataReceivedCallback");
            Main.selectedVideo = 0;
            document.getElementById("loadingIcon").style.display = "none";
            Display.currentWindow = 0;
            alert("state :" + Main.state);
            switch (Main.state) {
                case "top":
                    Main.selectedVideo = Main.topSelect;
                    Display.currentWindow = Main.topSelect;
                    Display.setVideoList();
                    break;
                case "genrelist":
                    Display.setVideoList();
                    break;
                default:
                    Display.setVideoList();
                    break;
            }
        }
		
		Server.ParseTopmenu();
        Display.setVideoList();
        Main.selectedVideo = 0;
        Display.setTitle(this.windowTitle);
        widgetAPI.sendReadyEvent();
        // Enable key event processing
        Main.enableKeys();
        
    }
    else
    {
        alert("Failed to initialise");
    }
}

// Call API for Volume OSD
onShowEvent = function()
{
	//Show Volume OSD
	document.getElementById('pluginObjectNNavi').SetBannerState(1);
	//Unregisters Keys
	pluginAPI.unregistKey(tvKey.KEY_VOL_UP);    //unregisters volume up button
	pluginAPI.unregistKey(tvKey.KEY_VOL_DOWN);  //unregisters volume down button
	pluginAPI.unregistKey(tvKey.KEY_MUTE);      //unregisters mute button
}


Main.onUnload = function()
{
    Player.deinit();
}

Main.updateCurrentVideo = function(move)
{
    //Player.setVideoURL( Data.getVideoURL(this.selectedVideo) );
    
    Display.setVideoListPosition(this.selectedVideo, move);

    Display.setDescription( Data.getVideoTitle(this.selectedVideo), Data.getVideoDescription(this.selectedVideo));
    Display.setImage(Main.selectedVideo);
}

Main.enableKeys = function()
{
    document.getElementById("anchor").focus();
}

Main.keyDown = function()
{
    if(Main.IGNORE_ALL == false)
    {
        switch(this.inputMode){
            default:Main.keyDownNormal();break;
            case 1:Main.keyDownSettings();break;
            case 2:Main.keyDownSearch();break;
            case 4:Main.splashDone();break;
        }
    }
    else
    {
        alert("Ignoring key press");
    }
}

Main.keyDownNormal = function()
{
    var keyCode = event.keyCode;
//    alert("Key pressed: " + keyCode);
    
    switch(keyCode)
    {
        case tvKey.KEY_EXIT:
            widgetAPI.blockNavigation(event);
            alert("Quit widget");
            widgetAPI.sendReturnEvent();
            break;
        case tvKey.KEY_RETURN:
        case tvKey.KEY_PANEL_RETURN:
            widgetAPI.blockNavigation(event);
            alert("RETURN");
            Main.handleReturnKey();
            break;

        case tvKey.KEY_MENU:
            alert("MENU " + this.inputMode);
            break;
        case tvKey.KEY_PLAY:
            alert("PLAY");
            this.handlePlayKey();
            break;
            
        case tvKey.KEY_STOP:
            alert("STOP");
            Player.stopVideo();
            break;
            
        case tvKey.KEY_PAUSE:
            alert("PAUSE");
            this.handlePauseKey();
            break;
        case tvKey.KEY_1:
			if (Player.getState() == Player.PLAYING)
				{
				if (this.mode == this.FULLSCREEN)
					Main.setWindowModePlaystyle();
				else
					Main.setFullScreenMode();
				}
            break;          
        case tvKey.KEY_2:
			if (Player.getState() == Player.PLAYING)
				{
				if (this.mode == this.FULLSCREEN)
					Player.ZoomScreenIn();
				}
            break;          

        case tvKey.KEY_FF:
				Player.FFskip();
            break;
        
        case tvKey.KEY_RW:
				Player.RWskip();		
            break;

/*        case tvKey.KEY_VOL_UP:
        case tvKey.KEY_PANEL_VOL_UP:
            alert("VOL_UP");
            if(this.mute == 0)
                Audio.setRelativeVolume(0);
            break;
            
        case tvKey.KEY_VOL_DOWN:
        case tvKey.KEY_PANEL_VOL_DOWN:
            alert("VOL_DOWN");
            if(this.mute == 0)
                Audio.setRelativeVolume(1);
            break;      
*/
        case tvKey.KEY_CH_UP:
            alert("CH_UP");
            if(this.inputMode == 0)
                document.getElementById("description").scrollTop -= 10;
            break;

        case tvKey.KEY_CH_DOWN:
            alert("CH_DOWN");
            if(this.inputMode == 0)
                document.getElementById("description").scrollTop += 10;
            break;
            
        case tvKey.KEY_LEFT:
            if(this.inputMode == 0)
                this.jumpPreviousVideo();
            break;
            
        case tvKey.KEY_RIGHT:
            if(this.inputMode == 0)
                this.jumpNextVideo();
            break;
            
        case tvKey.KEY_UP:
            if(this.inputMode == 0)
                this.selectPreviousVideo(this.UP);
            break;       
            
        case tvKey.KEY_DOWN:
            if(this.inputMode == 0)
                this.selectNextVideo(this.DOWN);
            break;            

        case tvKey.KEY_ENTER:
        case tvKey.KEY_PANEL_ENTER:
            alert("ENTER");
            this.handleEnterKey();
            break;
        
        case tvKey.KEY_MUTE:
            alert("MUTE");
            this.muteMode();
            break;
            
        case tvKey.KEY_INFO:
            alert("INFO");
            this.handleInfoKey();
            break;
            
        default:
            alert("Unhandled key");
            break;
    }
}

Main.keyDownSettings = function()
{
    var keyCode = event.keyCode;
//    alert("Key pressed: " + keyCode);
    
    switch(keyCode)
    {
        case tvKey.KEY_EXIT:
            widgetAPI.blockNavigation(event);
            alert("MENU " + this.inputMode);
            this.inputMode = 0;
            break;
        case tvKey.KEY_RETURN:
        case tvKey.KEY_PANEL_RETURN:
            widgetAPI.blockNavigation(event);
            alert("RETURN");
            this.inputMode = 0;
            break;
        case tvKey.KEY_MENU:
            alert("MENU " + this.inputMode);
            this.inputMode = 0;
            break;
        case tvKey.KEY_1:
            break;
        case tvKey.KEY_4:
            break;
        case tvKey.KEY_2:
            break;
        case tvKey.KEY_5:
            break;
        case tvKey.KEY_3:
            break;
        case tvKey.KEY_6:
            break;
        default:
            alert("Unhandled key");
            break;
    }
}

Main.handleReturnKey = function()
{
    switch ( this.mode )
    {
        case this.FULLSCREEN:
			alert("Fullscreen mode on return key");
			this.setWindowModePlaystyle();
            break;
        case this.WINDOW:
		    //this.selectedVideo=0;
			//this.topSelect = 0;
			//this.previousSelect = 0;

            alert("return from state " + this.state);
            switch (this.state) {
                case "top":
                    alert("Ignoring return key on top level");
                    break;
                case "genrelist":
                    // Store window position
                    /*for(i=0; i<TopData.length; i++){
                        if(TopData[i].state == Main.state){
                            TopData[i].position = Main.selectedVideo;
                            TopData[i].cw = Display.currentWindow;
                            alert("Storing " + Main.state + " cw:" + Display.currentWindow + "pos:" + Main.selectedVideo);
                        }
                    }*/
                    Server.ParseTopmenu();
                    this.selectedVideo = Main.topSelect;
                    Display.currentWindow = Main.topSelect;
                    Display.setVideoList();
                    this.windowTitle = "DR Bonanza";
                    //Update headline
                    Display.setTitle(this.windowTitle);
                    this.state = "top";
                    break;
                case "subseries":
                    alert("return from subseries");
                    URL = TopData[Main.topSelect].link;
                    if(URL != null){
                        this.state = "genrelist";//set next state
						Server.ParseKategorier (URL);
                        //Update headline
                        Display.setTitle("DR Bonanza" + " > " + TopData[Main.topSelect].title);
                    }
                    break;
                default:
                    alert("Going back from unknown state");
                    break;
            }
    }
}
Main.handlePlayKey = function()
{
    switch ( Player.getState() )
    {
        case Player.STOPPED:
            break;            
        case Player.PAUSED:
            Player.resumeVideo();break;            
        default:
            alert("Ignoring play key, not in correct state");break;
    }
}

Main.handlePauseKey = function()
{
    switch ( Player.getState() )
    {
        case Player.PLAYING:
            Player.pauseVideo();break;
        case Player.PAUSED:
            Player.resumeVideo();break;       
        default:
            alert("Ignoring pause key, not in correct state");break;
    }
}

Main.selectNextVideo = function(down)
{
    this.selectedVideo = (this.selectedVideo + 1) % Data.getVideoCount();
    this.updateCurrentVideo(down);
}

Main.jumpNextVideo = function()
{
    if( (this.selectedVideo+9) > (Data.getVideoCount()-1) )
    {
        this.selectedVideo = Data.getVideoCount() -1;
        alert("jump maxed");
    }else{
        this.selectedVideo += 9;
    }
    this.updateCurrentVideo(9);
}
Main.jumpPreviousVideo = function()
{
    if(this.selectedVideo-9 < 0 )
    {
        this.selectedVideo = 0;
    }else{
        this.selectedVideo -= 9;
    }
    this.updateCurrentVideo(-9);
}

Main.selectPreviousVideo = function(up)
{
    if (--this.selectedVideo < 0)
    {
        this.selectedVideo += Data.getVideoCount();
    }
    this.updateCurrentVideo(up);
}

Main.setFullScreenMode = function()
{
    if (this.mode != this.FULLSCREEN)
    {
        Display.hide();
        Player.setFullscreen();
        this.mode = this.FULLSCREEN;
    }
}

Main.setWindowMode = function()
{
    if (this.mode != this.WINDOW)
    {
        Display.show();
        Player.setWindow();
        this.mode = this.WINDOW;
    }
}

Main.setWindowModePlaystyle = function()
{
    if (this.mode != this.WINDOW)
    {
	    document.getElementById("main").style.display="inline";
        Player.setWindow();
        this.mode = this.WINDOW;
    }
alert ("Set Window mode");
}


Main.handleInfoKey = function()
{
    alert("infokey");
    Display.infoShow();
    Display.infoHide();
}

Main.handleEnterKey = function()
{
	if (this.mode == this.FULLSCREEN)
		{
			Main.setWindowModePlaystyle();
		}
    else {
        //Update values based on selection
        this.previousURL = this.currentURL;//Store old URL for use of return key
        this.previousState = this.state;
        this.previousSelect = this.selectedVideo;
        
        switch (this.state) 
		  {
            case "top":
                alert("state:top");
                URL = Data.link[this.selectedVideo];
                    if(URL != null){
                        Main.topSelect = this.selectedVideo;
                        this.state = 'genrelist';//set next state
						Server.ParseKategorier(URL);
                        //Update headline
						Display.setTitle("DR Bonanza" + " > " + TopData[Main.topSelect].title);
                    }
                break;
			case "subseries":
						Player.setVideoURL (Data.link[this.selectedVideo]);
						Player.playVideo ();
				break;
            case "genrelist":
                /* for(i=0; i<TopData.length; i++){
                    if(TopData[i].state == Main.state){
                        TopData[i].position = Main.selectedVideo;
                        TopData[i].cw = Display.currentWindow;
                        alert("Storing position:" + Main.selectedVideo);
                    }
                }*/
                URL = Data.link[this.selectedVideo];
                this.state = "subseries";//set next state
                //Update headline
				Display.setTitle("DR Bonanza" + " > " + TopData[Main.topSelect].title + " > " + Data.title[this.selectedVideo]);
				alert (Data.title[this.selectedVideo]);
				Server.ParseSerieEpisodes(URL);
                // Store window position
            break;
            default:
                alert("default state");
                break;
          }
		}
}

